gi-pango-1.0.19: Pango bindings

Copyright | Will Thompson Iñaki García Etxebarria and Jonas Platte
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria (garetxe@gmail.com)
Safe Haskell | None
Language | Haskell2010

GI.Pango.Objects.FontMap

Contents

- Exported types
- Methods
  - changed
  - createContext
  - getSerial
  - getShapeEngineType
  - listFamilies
  - loadFont
  - loadFontset

Description

The `FontMap` represents the set of fonts available for a particular rendering system. This is a virtual object with implementations being specific to particular rendering systems. To create an implementation of a `FontMap`, the rendering-system specific code should allocate a larger structure that contains a nested `FontMap`, fill in the <structfield>klass</structfield> member of the nested `FontMap` with a pointer to a appropriate `FontMapClass`, then call `pango_font_map_init()` on the structure.

The `FontMap` structure contains one member which the implementation fills in.

Synopsis

- newtype FontMap = FontMap (ManagedPtr FontMap)
- class GObject o => IsFontMap o
- toFontMap :: (MonadIO m, IsFontMap o) => o -> m FontMap
- noFontMap :: Maybe FontMap
- fontMapChanged :: (HasCallStack, MonadIO m, IsFontMap a) => a -> m ()
- fontMapCreateContext :: (HasCallStack, MonadIO m, IsFontMap a) => a -> m Context
- fontMapGetSerial :: (HasCallStack, MonadIO m, IsFontMap a) => a -> m Word32
- fontMapGetShapeEngineType :: (HasCallStack, MonadIO m, IsFontMap a) => a -> m Text
- fontMapListFamilies :: (HasCallStack, MonadIO m, IsFontMap a) => a -> m [FontFamily]
- fontMapLoadFont :: (HasCallStack, MonadIO m, IsFontMap a, IsContext b) => a -> b -> FontDescription -> m (Maybe Font)
- fontMapLoadFontset :: (HasCallStack, MonadIO m, IsFontMap a, IsContext b) => a -> b -> FontDescription -> Language -> m (Maybe Fontset)

# Exported types

newtype FontMap Source #

Memory-managed wrapper type.

Constructors

FontMap (ManagedPtr FontMap) |

Instances

GObject FontMap Source # |
Instance details Defined in GI.Pango.Objects.FontMap Methods gobjectType :: FontMap -> IO GType Source #
IsObject FontMap Source # |
Instance details Defined in GI.Pango.Objects.FontMap
IsFontMap FontMap Source # |
Instance details Defined in GI.Pango.Objects.FontMap

class GObject o => IsFontMap o Source #

Type class for types which can be safely cast to `FontMap`, for instance with `toFontMap`.

Instances

(GObject a, (UnknownAncestorError FontMap a :: Constraint)) => IsFontMap a Source # |
Instance details Defined in GI.Pango.Objects.FontMap
IsFontMap FontMap Source # |
Instance details Defined in GI.Pango.Objects.FontMap

toFontMap :: (MonadIO m, IsFontMap o) => o -> m FontMap Source #

Cast to `FontMap`, for types for which this is known to be safe. For general casts, use `castTo`.

noFontMap :: Maybe FontMap Source #

A convenience alias for `Nothing` :: `Maybe` `FontMap`.

# Methods

## changed

fontMapChanged Source #

Arguments

:: (HasCallStack, MonadIO m, IsFontMap a) |
=> a | `fontmap`: a `FontMap`
-> m () |

Forces a change in the context, which will cause any `Context` using this fontmap to change.

This function is only useful when implementing a new backend for Pango, something applications won't do. Backends should call this function if they have attached extra data to the context and such data is changed.

Since: 1.34

## createContext

fontMapCreateContext Source #

Arguments

:: (HasCallStack, MonadIO m, IsFontMap a) |
=> a | `fontmap`: a `FontMap`
-> m Context | Returns: the newly allocated `Context`, which should be freed with `objectUnref`.

Creates a `Context` connected to `fontmap`. This is equivalent to `contextNew` followed by `contextSetFontMap`.

If you are using Pango as part of a higher-level system, that system may have it's own way of create a `Context`. For instance, the GTK+ toolkit has, among others, `gdk_pango_context_get_for_screen()`, and `gtk_widget_get_pango_context()`. Use those instead.

Since: 1.22

## getSerial

fontMapGetSerial Source #

Arguments

:: (HasCallStack, MonadIO m, IsFontMap a) |
=> a | `fontmap`: a `FontMap`
-> m Word32 | Returns: The current serial number of `fontmap`.

Returns the current serial number of `fontmap`. The serial number is initialized to an small number larger than zero when a new fontmap is created and is increased whenever the fontmap is changed. It may wrap, but will never have the value 0. Since it can wrap, never compare it with "less than", always use "not equals".

The fontmap can only be changed using backend-specific API, like changing fontmap resolution.

This can be used to automatically detect changes to a `FontMap`, like in `Context`.

Since: 1.32.4

## getShapeEngineType

fontMapGetShapeEngineType Source #

Arguments

:: (HasCallStack, MonadIO m, IsFontMap a) |
=> a | `fontmap`: a `FontMap`
-> m Text | Returns: the ID string for shape engines for this fontmap. Owned by Pango, should not be modified or freed.

Deprecated: (Since version 1.38)

Returns the render ID for shape engines for this fontmap. See the <structfield>render_type</structfield> field of `EngineInfo`.

Since: 1.4

## listFamilies

fontMapListFamilies Source #

Arguments

:: (HasCallStack, MonadIO m, IsFontMap a) |
=> a | `fontmap`: a `FontMap`
-> m [FontFamily] |

List all families for a fontmap.

## loadFont

fontMapLoadFont Source #

Arguments

:: (HasCallStack, MonadIO m, IsFontMap a, IsContext b) |
=> a | `fontmap`: a `FontMap`
-> b | `context`: the `Context` the font will be used with
-> FontDescription | `desc`: a `FontDescription` describing the font to load
-> m (Maybe Font) | Returns: the newly allocated `Font` loaded, or `Nothing` if no font matched.

Load the font in the fontmap that is the closest match for `desc`.

## loadFontset

fontMapLoadFontset Source #

Arguments

:: (HasCallStack, MonadIO m, IsFontMap a, IsContext b) |
=> a | `fontmap`: a `FontMap`
-> b | `context`: the `Context` the font will be used with
-> FontDescription | `desc`: a `FontDescription` describing the font to load
-> Language | `language`: a `Language` the fonts will be used for
-> m (Maybe Fontset) | Returns: the newly allocated `Fontset` loaded, or `Nothing` if no font matched.

Load a set of fonts in the fontmap that can be used to render a font matching `desc`.